////////////////////////////////////////////////////////////////////////////////////////////////
//
// Material Selector for ObjectLuminous.fx
//    Stage01 Edition Modified
//
////////////////////////////////////////////////////////////////////////////////////////////////
// [U[p[^

// Rg[pfƃ[t(ftHgł̓Rg[p[tEmittion1 ` Emittion3)
// ől̎AGainŐݒ肵邳ɂȂ܂BPMX̏ꍇAݒ肳ĂȂގ[tŖ肠܂
// Rg[Ȃꍇ͉4sRgAEgĂ
//#define ControllEmission
//float Emittion1 : CONTROLOBJECT < string name = ""; string item = "Emittion1"; >;
//float Emittion2 : CONTROLOBJECT < string name = ""; string item = "Emittion2"; >;
//float Emittion3 : CONTROLOBJECT < string name = ""; string item = "Emittion3"; >;

#ifndef ControllEmission
float Emittion1 = 1;
float Emittion2 = 1;
float Emittion3 = 1;
#endif

//ΏۂƂfނ̃TuZbgԍ
#define TargetSubset1 ""
#define TargetSubset2 ""
#define TargetSubset3 ""

//ˌŕȂf
#define BlockSubset ""

//F (RGBAevf 0.0`1.0)
float4 Emittion_Color1
<
   string UIName = "Emittion Color1";
   string UIWidget = "Color";
   bool UIVisible =  true;
   float UIMin = 0.0; float UIMax = 1.0;
> = float4( 0, 0, 0, 0 );

float4 Emittion_Color2
<
   string UIName = "Emittion Color2";
   string UIWidget = "Color";
   bool UIVisible =  true;
   float UIMin = 0.0; float UIMax = 1.0;
> = float4( 0, 0, 0, 0 );

float4 Emittion_Color3
<
   string UIName = "Emittion Color3";
   string UIWidget = "Color";
   bool UIVisible =  true;
   float UIMin = 0.0; float UIMax = 1.0;
> = float4( 0, 0, 0, 0 );

//QC
float Gain1
<
   string UIName = "Gain 1";
   string UIWidget = "Slider";
   bool UIVisible =  true;
   float UIMin = 0.0; float UIMax = 5.0;
> = float( 0.5 );

float Gain2
<
   string UIName = "Gain 2";
   string UIWidget = "Slider";
   bool UIVisible =  true;
   float UIMin = 0.0; float UIMax = 5.0;
> = float( 0.5 );

float Gain3
<
   string UIName = "Gain 3";
   string UIWidget = "Slider";
   bool UIVisible =  true;
   float UIMin = 0.0; float UIMax = 5.0;
> = float( 0.5 );


//eNX`pL[J[
float4 KeyTexColor1
<
   string UIName = "KeyTexColor1";
   string UIWidget = "Color";
   bool UIVisible =  true;
   float UIMin = 0.0; float UIMax = 1.0;
> = float4( 0, 0, 0, 0 );

float4 KeyTexColor2
<
   string UIName = "KeyTexColor2";
   string UIWidget = "Color";
   bool UIVisible =  true;
   float UIMin = 0.0; float UIMax = 1.0;
> = float4( 0, 0, 0, 0 );

float4 KeyTexColor3
<
   string UIName = "KeyTexColor3";
   string UIWidget = "Color";
   bool UIVisible =  true;
   float UIMin = 0.0; float UIMax = 1.0;
> = float4( 0, 0, 0, 0 );

//L[J[F臒l
float KeyThreshold
<
   string UIName = "Key Threshold";
   string UIWidget = "Slider";
   bool UIVisible =  true;
   float UIMin = 0.0; float UIMax = 1.0;
> = float( 0.2 );

////////////////////////////////////////////////////////////////////////////////////////////////

float4 MaterialDiffuse : DIFFUSE  < string Object = "Geometry"; >;
static float alpha1 = MaterialDiffuse.a;

bool use_texture;  //eNX`̗L

// IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE;
sampler ObjTexSampler = sampler_state
{
    texture = <ObjectTexture>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
};

// MMD{sampler㏑Ȃ߂̋Lq
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);

////////////////////////////////////////////////////////////////////////////////////////////////

bool ColorMuch(float4 color1, float4 key){
    float4 s = color1 - key;
    return (length(s.rgb) <= KeyThreshold);
}



// @ϊs
float4x4 WorldViewProjMatrix      : WORLDVIEWPROJECTION;
float4x4 WorldMatrix              : WORLD;
float4x4 ViewMatrix               : VIEW;
float3   CameraPosition    : POSITION  < string Object = "Camera"; >;

struct VS_OUTPUT {
    float4 Pos        : POSITION;    // ˉeϊW
    float2 Tex        : TEXCOORD1;   // eNX`
    float3 Normal     : TEXCOORD2;   // @
    float3 Eye        : TEXCOORD3;   // JƂ̑Έʒu
    float2 SpTex      : TEXCOORD4;	 // XtBA}bveNX`W
    float4 WorldPos      : TEXCOORD5;     // [hԍW
    float4 Color      : COLOR0;      // fBt[YF
};


// _VF[_
VS_OUTPUT Basic_VS(float4 Pos : POSITION, float3 Normal : NORMAL, float2 Tex : TEXCOORD0, uniform bool useTexture, uniform bool useSphereMap, uniform bool useToon)
{
    VS_OUTPUT Out = (VS_OUTPUT)0;
    Out.WorldPos = Pos;
    // J_̃[hr[ˉeϊ
    Out.Pos = mul( Pos, WorldViewProjMatrix );
    
    // JƂ̑Έʒu
    Out.Eye = CameraPosition - mul( Pos, WorldMatrix );
    // _@
    Out.Normal = normalize( mul( Normal, (float3x3)WorldMatrix ) );
    
    // eNX`W
    Out.Tex = Tex;

    return Out;
}

////////////////////////////////////////////////////////////////////////////////////////////////
//sNZVF[_

float4 PS_Selected1(VS_OUTPUT IN,float2 Tex : TEXCOORD1) : COLOR {
    float2 tex = abs(frac(IN.Tex)*0.5);
    float4 texcolor;
    float4 color = Emittion_Color1;
    float alpha = alpha1;
    if ( use_texture ) {
		float2 BaseTex = tex;
		float3 Eye = IN.Eye;
		tex = tex - Eye.xy * tex2D( ObjTexSampler, tex+float2(0.5,0.5)).r * 0.0001;
        tex = clamp(tex,0,0.4995);
		texcolor = tex2D( ObjTexSampler, BaseTex );
        alpha *= texcolor.a;
//    alpha *= tex2D( ObjTexSampler, Tex ).a;
        
        if(KeyTexColor1.a > 0.1){
            if(!(ColorMuch(texcolor, KeyTexColor1))) color.rgb = 0;
        }
	}
    color.rgb *= (Gain1 * alpha * Emittion1);
    return color;
}
float4 PS_Selected2(VS_OUTPUT IN,float2 Tex : TEXCOORD1) : COLOR {
    float2 tex = abs(frac(IN.Tex)*0.5);
    float4 texcolor;
    float4 color = Emittion_Color2;
    float alpha = alpha1;
    if ( use_texture ) {
		float2 BaseTex = tex;
		float3 Eye = IN.Eye;
		tex = tex - Eye.xy * tex2D( ObjTexSampler, tex+float2(0.5,0.5)).r * 0.0001;
        tex = clamp(tex,0,0.4995);
		texcolor = tex2D( ObjTexSampler, BaseTex );
        alpha *= texcolor.a;
//    alpha *= tex2D( ObjTexSampler, Tex ).a;
        
        if(KeyTexColor2.a > 0.1){
            if(!(ColorMuch(texcolor, KeyTexColor2))) color.rgb = 0;
        }
	}
    color.rgb *= (Gain2 * alpha * Emittion2);
    return color;
}
float4 PS_Selected3(VS_OUTPUT IN,float2 Tex : TEXCOORD1) : COLOR {
    float2 tex = abs(frac(IN.Tex)*0.5);
    float4 texcolor;
    float4 color = Emittion_Color3;
    float alpha = alpha1;
    if ( use_texture ){
		float2 BaseTex = tex;
		float3 Eye = IN.Eye;
		tex = tex - Eye.xy * tex2D( ObjTexSampler, tex+float2(0.5,0.5)).r * 0.0001;
        tex = clamp(tex,0,0.4995);
//        texcolor = tex2D( ObjTexSampler, Tex );
		texcolor = tex2D( ObjTexSampler, BaseTex );
        alpha *= texcolor.a;
        
        if(KeyTexColor3.a > 0.1){
            if(!(ColorMuch(texcolor, KeyTexColor3))) color.rgb = 0;
        }
    }
    color.rgb *= (Gain3 * alpha * Emittion3);
    return color;
}

float4 PS_Block() : COLOR {
    return float4(0.0, 0.0, 0.0, 0.2);
}
float4 PS_Black(float2 Tex : TEXCOORD1) : COLOR {
    float alpha = alpha1;
    if ( use_texture ) alpha *= tex2D( ObjTexSampler, Tex ).a;
    return float4(0.0, 0.0, 0.0, alpha);
}

////////////////////////////////////////////////////////////////////////////////////////////////
//eNjbN

//ZtVhEȂ
technique Select1 < string Subset = TargetSubset1; > {
    pass Single_Pass {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_2_0 Basic_VS(true, true, true);
        PixelShader = compile ps_2_0 PS_Selected1();
    }
}
technique Select2 < string Subset = TargetSubset2; > {
    pass Single_Pass {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_2_0 Basic_VS(true, true, true);
        PixelShader = compile ps_2_0 PS_Selected2();
    }
}
technique Select3 < string Subset = TargetSubset3; > {
    pass Single_Pass {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_2_0 Basic_VS(true, true, true);
        PixelShader = compile ps_2_0 PS_Selected3();
    }
}

technique  Block < string Subset = BlockSubset; > {
    pass Single_Pass {
        AlphaBlendEnable = FALSE;
        PixelShader = compile ps_2_0 PS_Block();
    }
}
technique Mask {
    pass Single_Pass { PixelShader = compile ps_2_0 PS_Black(); }
}

//ZtVhE
technique Select1SS < string MMDPass = "object_ss"; string Subset = TargetSubset1; > {
    pass Single_Pass {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_2_0 Basic_VS(true, true, true);
        PixelShader = compile ps_2_0 PS_Selected1();
    }
}
technique Select2SS < string MMDPass = "object_ss"; string Subset = TargetSubset2; > {
    pass Single_Pass {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_2_0 Basic_VS(true, true, true);
        PixelShader = compile ps_2_0 PS_Selected2();
    }
}
technique Select3SS < string MMDPass = "object_ss"; string Subset = TargetSubset3; > {
    pass Single_Pass {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_2_0 Basic_VS(true, true, true);
        PixelShader = compile ps_2_0 PS_Selected3();
    }
}

technique  BlockSS < string MMDPass = "object_ss"; string Subset = BlockSubset; > {
    pass Single_Pass {
        AlphaBlendEnable = FALSE;
        PixelShader = compile ps_2_0 PS_Block();
    }
}
technique MaskSS < string MMDPass = "object_ss"; > {
    pass Single_Pass { PixelShader = compile ps_2_0 PS_Black(); }
}

//e֊s͕`悵Ȃ
technique EdgeTec < string MMDPass = "edge"; > { }
technique ShadowTec < string MMDPass = "shadow"; > { }
technique ZplotTec < string MMDPass = "zplot"; > { }

